#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdbool.h>

#define MAX_LENGTH 30 + 1
#define MAX_ITEM 1000
#define MAX_PRODNUM 20


void kosar(char t[][MAX_LENGTH], int sorszam, int* eleje, int* vege)
	{
	/*sorszam elotti "F"-et koveto kivalasztasa. Nem ellenorzom, hogy letezik-e*/
	int i = 0;
	int melyik = 0;
	while(melyik < sorszam - 1) {
			if (strcmp(t[i], "F") == 0)
				melyik ++;
			i++;
			}
	*eleje = i;

	/*utana, ami a kosarban van "F"-ig*/
	while(strcmp(t[i], "F") != 0)
		i++;
	*vege = i;
	}

bool vankosarban(char t[][MAX_LENGTH], int sorszam, char mi[MAX_LENGTH])
	{
	int i = 0;
	int melyik = 0;
	while(melyik < sorszam - 1) {
			if (strcmp(t[i], "F") == 0)
				melyik ++;
			i++;
			}

	/*van-e mi*/
	while(strcmp(t[i], "F") != 0 && strcmp(t[i], mi) != 0 )
		i++;
	return strcmp(t[i], "F") != 0;
	}

int ertek(int db)
	{
	switch (db) {
			case 0:       /*nem kell, de elvileg lehetne*/
				return 0;
			case 1:
				return 500;
			case 2:
				return 950;
			default:
				return 950 + (db - 2) * 400;
			}
	}

int main()
	{
	char t[MAX_ITEM][MAX_LENGTH];
	int i, j, k; /*altalanos iterator*/
	char s[MAX_LENGTH]; /*egy string tarolo*/


	/*1. feladat*/
	FILE *f;
	f = fopen("penztar.txt", "rt");
	int n = 0;      /*sorok szama*/

	while (fscanf(f, " %[^\n]", s ) != EOF) {
			strcpy(t[n], s);
			n++;
			}
	fclose(f);
	/*printf("%d", n);*/


	/*2. feladat*/
	printf( "\n2. feladat\n");
	int fizDB = 0;
	for (i = 0; i < n; i++)
		if(strcmp(t[i], "F") == 0)
			fizDB++;
	printf("A fizetesek szama: %d\n", fizDB);


	/*3. feladat*/
	printf("\n3. feladat\n");
	int e = 0, v = 0;
	kosar(t, 1, &e, &v);
	printf("Az elso vasarlo %d darab arucikket vasarolt.\n", v - e);


	/*4. feladat*/
	printf("\n4. feladat\n");
	int kszam;          /*egy kosarszam (nagyon zavaro, hogy feladatokkal korabban kell bekerni adatot)*/
	int edb;            /*egysegek szama osszegszamitashoz*/
	printf("Adja meg egy vasarlas sorszamat! ");
	scanf("%d", &kszam);
	printf("Adja meg egy arucikk nevet! ");
	scanf(" %[^\n]", s);
	printf("Adja meg a vasarolt darabszamot! ");
	scanf("%d", &edb);


	/*5. feladat*/
	printf("\n5. feladat\n");
	int elso = -1;
	int utolso = -1;
	int sDB = 0;
	for (i = 1; i <= fizDB; ++i)
		if (vankosarban(t, i, s)) { /*az i-edik kosarban van-e az s termekbol*/
				if (elso == -1) elso = i; /*elso ilyen kosar*/
				utolso = i;
				sDB++;
				}
	printf("Az elso vasarlas sorszama: %d\n", elso);
	printf("Az utolso vasarlas sorszama: %d\n", utolso);
	printf("%d vasarlas soran vettek belole.\n", sDB);


	/*6. feladat*/
	printf("\n6. feladat\n");
	printf("%d darab vetelekor fizetendo: %d", edb, ertek(edb));


	/*7. feladat*/
	printf("\n7. feladat\n");
	char aru [MAX_PRODNUM][MAX_LENGTH];
	int aDB[MAX_PRODNUM];
	int prodnum = 0;            /*ellenorzes nelkul prodnum <= MAX_PRODNUM*/
	kosar(t, kszam, &e, &v);    /*kszam-adik kosar eleje es vege*/
	for (i = e; i < v; ++i) {   /*i-edik termek keresese az aru-ban*/
			j = 0;
			while(j < prodnum && strcmp(aru [j], t[i]) != 0)
        j++;
			if(j == prodnum) {
					strcpy(aru[j], t[i]);
					aDB[j] = 1;
					prodnum++;
					}
			else
				aDB[j]++;
			}
	for(j = 0; j < prodnum; ++j)
		printf("%d %s\n", aDB[j], aru[j]);


	/*8. feladat*/
	printf("\n8. feladat\n");
	f = fopen("osszeg.txt", "wt");

	for (i = 1; i <= fizDB; ++i) {        /*minden kosarra*/
			for(j = 0; j < MAX_PRODNUM; ++j) { /*termekenkenti darabszam nullazasa, a mar megtalalt termekek maradnak*/
					aDB[j] = 0;
					}
			prodnum = 0;                       /*elozo kosar termekeinek "torlese"*/
			kosar(t, i, &e, &v);
			for (k = e; k < v; ++k) {         /*minden, az i. kosarban levo termekre*/
					j = 0;
					while(j < prodnum && strcmp(aru[j], t[k]) != 0)
						j++;
					if(j == prodnum) {            /*korabban egyaltalan nem szerepelt*/
							strcpy(aru[j], t[i]);
							aDB[j] = 1;
							prodnum++;
							}
					else
						aDB[j]++;
					}
			int szum = 0;
			for(j = 0; j < prodnum; ++j)
				szum += ertek(aDB[j]);
			fprintf(f, "%d: %d\n", i, szum);
			}

	fclose(f);
	printf("Eredmeny az osszeg.txt fajlban");

	return 0;
	}
